#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=.\Bilder\icon.ico
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_LegalCopyright=TheShadowAE
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <imgfilter.au3>

#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <GuiComboBox.au3>
#include <File.au3>
#include <Array.au3>



Dim $controls[11][13]
$version="0.1"

#Region ### START Koda GUI section ### Form=
$Form1 = GUICreate("Filter und Effekte fr Bilder", 1010, 640)
GUISetIcon(@ScriptDir&"\Bilder\icon.ico")
$MenuItem1 = GUICtrlCreateMenu("Datei")
$oeffnen = GUICtrlCreateMenuItem("ffnen           Strg+O", $MenuItem1)
$speichern = GUICtrlCreateMenuItem("Speichern       Strg+S", $MenuItem1)
$speichernunter = GUICtrlCreateMenuItem("Speichern unter", $MenuItem1)
$MenuItem6 = GUICtrlCreateMenuItem("", $MenuItem1)
$schliessen = GUICtrlCreateMenuItem("Schlieen        Alt+F4", $MenuItem1)
$MenuItem2 = GUICtrlCreateMenu("Hilfe")
$hilfe = GUICtrlCreateMenuItem("Hilfe      F1", $MenuItem2)
$about = GUICtrlCreateMenuItem("About", $MenuItem2)
$Funktion = GUICtrlCreateCombo("", 8, 8, 169, 25, BitOR($CBS_DROPDOWNLIST,$CBS_AUTOHSCROLL))
GUICtrlSetData(-1, "Matrix/Filter|Kantenerkennung|Bilder kombinieren (or)|Farbfilter|Farbton|Mosaik (schnell, ungenau)|Mosaik (sehr langsam, genau)|1 Bit|Schwarzwei|Negativ|Extension")
GUICtrlSetData(-1, "Matrix/Filter")

$controls[0][0] = GUICtrlCreateInput("0", 8, 40, 25, 21)
$controls[0][1] = GUICtrlCreateInput("0", 40, 40, 25, 21)
$controls[0][2] = GUICtrlCreateInput("0", 72, 40, 25, 21)
$controls[0][3] = GUICtrlCreateInput("0", 8, 64, 25, 21)
$controls[0][4] = GUICtrlCreateInput("1", 40, 64, 25, 21)
$controls[0][5] = GUICtrlCreateInput("0", 72, 64, 25, 21)
$controls[0][6] = GUICtrlCreateInput("0", 8, 88, 25, 21)
$controls[0][7] = GUICtrlCreateInput("0", 40, 88, 25, 21)
$controls[0][8] = GUICtrlCreateInput("0", 72, 88, 25, 21)
$controls[0][9] = GUICtrlCreateInput("1", 72, 120, 25, 21)
$controls[0][10] = GUICtrlCreateLabel("Divisor:", 8, 123, 39, 17)
$Icon1 = GUICtrlCreateIcon(@ScriptDir&"\Bilder\Undo.ico", -1, 192, 11, 16, 16, BitOR($SS_NOTIFY,$WS_GROUP))
$Icon2 = GUICtrlCreateIcon(@ScriptDir&"\Bilder\Redo.ico", -1, 216, 11, 16, 16, BitOR($SS_NOTIFY,$WS_GROUP))
$controls[0][11] = GUICtrlCreateButton("Vorschau", 8, 152, 89, 25, $WS_GROUP)
$controls[0][12] = GUICtrlCreateButton("OK", 8, 184, 89, 25, $WS_GROUP)

$controls[1][0] = GUICtrlCreateButton("Vorschau", 8, 40, 89, 25, $WS_GROUP)
$controls[1][1] = GUICtrlCreateButton("OK", 8, 72, 89, 25, $WS_GROUP)

$controls[2][0] = GUICtrlCreateInput("", 8, 40, 65, 21)
$controls[2][1] = GUICtrlCreateButton("..", 80, 40, 17, 25, $WS_GROUP)
$controls[2][2] = GUICtrlCreateButton("Vorschau", 8, 72, 89, 25, $WS_GROUP)
$controls[2][3] = GUICtrlCreateButton("OK", 8, 104, 89, 25, $WS_GROUP)

$controls[3][0] = GUICtrlCreateInput("0xFFFFFF", 8, 40, 89, 21, BitOR($ES_RIGHT,$ES_AUTOHSCROLL))
$controls[3][1] = GUICtrlCreateButton("Vorschau", 8, 68, 89, 25, $WS_GROUP)
$controls[3][2] = GUICtrlCreateButton("OK", 8, 100, 89, 25, $WS_GROUP)

$controls[4][0] = GUICtrlCreateSlider(8, 40, 89, 29)
GUICtrlSetLimit(-1, 100, -100)
GUICtrlSetTip(-1, "Rot")
$controls[4][1] = GUICtrlCreateSlider(8, 80, 89, 29)
GUICtrlSetLimit(-1, 100, -100)
GUICtrlSetTip(-1, "Grn")
$controls[4][2] = GUICtrlCreateSlider(8, 120, 89, 29)
GUICtrlSetLimit(-1, 100, -100)
GUICtrlSetTip(-1, "Blau")
$controls[4][3] = GUICtrlCreateButton("Vorschau", 8, 160, 89, 25, $WS_GROUP)
$controls[4][4] = GUICtrlCreateButton("OK", 8, 192, 89, 25, $WS_GROUP)

$controls[5][0] = GUICtrlCreateLabel("Steingre:", 8, 43, 58, 17)
$controls[5][1] = GUICtrlCreateInput("5", 72, 40, 25, 21)
$controls[5][2] = GUICtrlCreateButton("Vorschau", 8, 64, 89, 25, $WS_GROUP)
$controls[5][3] = GUICtrlCreateButton("OK", 8, 96, 89, 25, $WS_GROUP)

$controls[6][0] = GUICtrlCreateLabel("Steingre:", 8, 43, 58, 17)
$controls[6][1] = GUICtrlCreateInput("5", 72, 40, 25, 21)
$controls[6][2] = GUICtrlCreateButton("Vorschau", 8, 64, 89, 25, $WS_GROUP)
$controls[6][3] = GUICtrlCreateButton("OK", 8, 96, 89, 25, $WS_GROUP)

$controls[7][0] = GUICtrlCreateButton("Vorschau", 8, 40, 89, 25, $WS_GROUP)
$controls[7][1] = GUICtrlCreateButton("OK", 8, 72, 89, 25, $WS_GROUP)

$controls[8][0] = GUICtrlCreateButton("Vorschau", 8, 40, 89, 25, $WS_GROUP)
$controls[8][1] = GUICtrlCreateButton("OK", 8, 72, 89, 25, $WS_GROUP)

$controls[9][0] = GUICtrlCreateButton("Vorschau", 8, 40, 89, 25, $WS_GROUP)
$controls[9][1] = GUICtrlCreateButton("OK", 8, 72, 89, 25, $WS_GROUP)

Local $items="",$item="",$file=_FileListToArray(@ScriptDir&"\Extensions\info","*.txt",1)
If IsArray($file) Then
	$item=StringTrimRight($file[1],4)
	For $x=1 To $file[0]
		$items&=StringTrimRight($file[$x],4)&"|"
	Next
EndIf
$items=StringTrimRight($items,1)
$controls[10][0] = GUICtrlCreateCombo("", 8, 40, 89, 25, BitOR($CBS_DROPDOWNLIST,$CBS_AUTOHSCROLL))
GUICtrlSetData(-1, $items)
GUICtrlSetData(-1, $item)
$controls[10][1] = GUICtrlCreateButton("Vorschau", 8, 72, 89, 25, $WS_GROUP)
$controls[10][2] = GUICtrlCreateButton("OK", 8, 104, 89, 25, $WS_GROUP)

For $x=1 To 10
	For $y=0 To 12
		GUICtrlSetState($controls[$x][$y],$GUI_HIDE)
	Next
Next
GUISetState(@SW_SHOW)
Dim $Form1_AccelTable[3][2] = [["^o", $oeffnen],["^s", $speichern],["{F1}", $hilfe]]
GUISetAccelerators($Form1_AccelTable)
GUIRegisterMsg(0x0006,"update");WM_ACTIVATE
AdlibRegister("_update",1000)
#EndRegion ### END Koda GUI section ###

_GDIPlus_Startup()
Dim $ahImages[3],$iW,$iH,$iNowimg=0,$iOldnowimg,$tTimer,$sBildDatei
Local $gra=_GDIPlus_GraphicsCreateFromHWND($Form1)
Local $hBuffer=_GDIPlus_BitmapCreateFromGraphics(1010,640,$gra)
Local $backgra=_GDIPlus_ImageGetGraphicsContext($hBuffer)



While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE,$schliessen
			ExitLoop
		Case $Funktion
			For $x=0 To 10
				For $y=0 To 12
					GUICtrlSetState($controls[$x][$y],$GUI_HIDE)
				Next
			Next
			$x=_GUICtrlComboBox_GetCurSel($Funktion)
			For $y=0 To 12
				GUICtrlSetState($controls[$x][$y],$GUI_SHOW)
			Next
		Case $about
			MsgBox(0,"About "&$version,"Dieses Programm wurde von TheShadowAE mit Hilfe von Andy"&@CRLF&"aus der Autoit.de Community programmiert!"&@CRLF&@CRLF&"Dies ist Version "&$version)
		Case $hilfe
			MsgBox(0,"Hilfe","Bei Bugs, Vorschlgen oder Sonstigem bitte im Thread oder per PN melden, danke!"&@CRLF&"Autoit.de - TheShadowAE"&@CRLF&@CRLF&"Weitere ntzliche Informationen in den Dateien Filter.txt und \Extensions\HowTo.txt!")
		Case $Icon1
			If $iNowimg=2 Then _EndVorschau()
			If $iNowimg=1 Then $iNowimg=0
			_update()
		Case $Icon2
			If $iNowimg=2 Then _EndVorschau()
			If $iNowimg=0 And $ahImages[1]<>0 Then $iNowimg=1
			_update()
		Case $oeffnen
			$sBildDatei=FileOpenDialog("Bild auswhlen", "", "Bilder(*.png;*.bmp;*.jpg)",3)
			$iNowimg=0
			$ahImages[0]=_GDIPlus_BitmapCreateFromFile($sBildDatei)
			_GDIPlus_BitmapDispose($ahImages[1])
			$ahImages[1]=0
			$iW=_GDIPlus_ImageGetWidth($ahImages[0])
			$iH=_GDIPlus_ImageGetHeight($ahImages[0])
			If $iW>900 Then
				$iH=($iH/$iW)*900
				$iW=900
			EndIf
			If $iH>600 Then
				$iW=($iW/$iH)*600
				$iH=600
			EndIf
			_update()
		Case $speichern
			If $iNowimg=2 Then _EndVorschau()
			_GDIPlus_ImageSaveToFile($ahImages[$iNowimg],$sBildDatei)
		Case $speichernunter
			If $iNowimg=2 Then _EndVorschau()
			$sBildDatei=FileSaveDialog("Bild speichern","","Bilder(*.png;*.bmp;*.jpg)",16)
			$end=StringRegExp($sBildDatei,"(?i)(?:\.bmp|\.jpg|\.png)",1)
			If @error Then $sBildDatei&=".png"
			_GDIPlus_ImageSaveToFile($ahImages[$iNowimg],$sBildDatei)
		Case $controls[0][11]
			If $iNowimg=2 Then _EndVorschau()
			$iOldnowimg=$iNowimg
			$iNowimg=2
			Local $arr[10]=[GUICtrlRead($controls[0][9]), _
							GUICtrlRead($controls[0][0]),GUICtrlRead($controls[0][1]),GUICtrlRead($controls[0][2]), _
							GUICtrlRead($controls[0][3]),GUICtrlRead($controls[0][4]),GUICtrlRead($controls[0][5]), _
							GUICtrlRead($controls[0][6]),GUICtrlRead($controls[0][7]),GUICtrlRead($controls[0][8])]
			$ahImages[2]=_Filter($ahImages[$iOldnowimg],$arr)
			_update()
			AdlibRegister("_EndVorschau",5000)
		Case $controls[0][12]
			If $iNowimg=2 Then _EndVorschau()
			If $iNowimg=0 Then
				_GDIPlus_BitmapDispose($ahImages[1])
			Else
				_GDIPlus_BitmapDispose($ahImages[0])
				$ahImages[0]=$ahImages[1]
			EndIf
			Local $arr[10]=[GUICtrlRead($controls[0][9]), _
							GUICtrlRead($controls[0][0]),GUICtrlRead($controls[0][1]),GUICtrlRead($controls[0][2]), _
							GUICtrlRead($controls[0][3]),GUICtrlRead($controls[0][4]),GUICtrlRead($controls[0][5]), _
							GUICtrlRead($controls[0][6]),GUICtrlRead($controls[0][7]),GUICtrlRead($controls[0][8])]
			$ahImages[1]=_Filter($ahImages[0],$arr)
			$iNowimg=1
			_update()
		Case $controls[1][0]
			If $iNowimg=2 Then _EndVorschau()
			$iOldnowimg=$iNowimg
			$iNowimg=2
			Local $arr[10]=[9,1,1,1,1,1,1,1,1,1]
			Local $temp=_Filter($ahImages[$iOldnowimg],$arr)
			Local $arr[10]=[1,1,1,1,1,-8,1,1,1,1]
			$ahImages[2]=_Filter($temp,$arr)
			_GDIPlus_BitmapDispose($temp)
			Local $arr[10]=[1,0,0,0,0,4,0,0,0,0]
			$temp=_Filter($ahImages[2],$arr)
			_GDIPlus_BitmapDispose($ahImages[2])
			$ahImages[2]=$temp
			_update()
			AdlibRegister("_EndVorschau",5000)
		Case $controls[1][1]
			If $iNowimg=2 Then _EndVorschau()
			If $iNowimg=0 Then
				_GDIPlus_BitmapDispose($ahImages[1])
			Else
				_GDIPlus_BitmapDispose($ahImages[0])
				$ahImages[0]=$ahImages[1]
			EndIf
			Local $arr[10]=[9,1,1,1,1,1,1,1,1,1]
			Local $temp=_Filter($ahImages[$iOldnowimg],$arr)
			Local $arr[10]=[1,1,1,1,1,-8,1,1,1,1]
			$ahImages[1]=_Filter($temp,$arr)
			_GDIPlus_BitmapDispose($temp)
			Local $arr[10]=[1,0,0,0,0,4,0,0,0,0]
			$temp=_Filter($ahImages[1],$arr)
			_GDIPlus_BitmapDispose($ahImages[1])
			$ahImages[1]=$temp
			$iNowimg=1
			_update()
		Case $controls[2][1]
			$file=FileOpenDialog("Bild auswhlen", "", "Bilder(*.png;*.bmp;*.jpg)",3)
			If Not @error And FileExists($file) Then GUICtrlSetData($controls[2][0],$file)
		Case $controls[2][2]
			If $iNowimg=2 Then _EndVorschau()
			$iOldnowimg=$iNowimg
			$iNowimg=2
			Local $temp=_GDIPlus_BitmapCreateFromFile(GUICtrlRead($controls[2][0]))
			$ahImages[2]=_or($ahImages[$iOldnowimg],$temp)
			_GDIPlus_BitmapDispose($temp)
			_update()
			AdlibRegister("_EndVorschau",5000)
		Case $controls[2][3]
			If $iNowimg=2 Then _EndVorschau()
			If $iNowimg=0 Then
				_GDIPlus_BitmapDispose($ahImages[1])
			Else
				_GDIPlus_BitmapDispose($ahImages[0])
				$ahImages[0]=$ahImages[1]
			EndIf
			Local $temp=_GDIPlus_BitmapCreateFromFile(GUICtrlRead($controls[2][0]))
			$ahImages[1]=_or($ahImages[0],$temp)
			_GDIPlus_BitmapDispose($temp)
			$iNowimg=1
			_update()
		Case $controls[3][1]
			If $iNowimg=2 Then _EndVorschau()
			$iOldnowimg=$iNowimg
			$iNowimg=2
			$ahImages[2]=_FarbFilterAnd($ahImages[$iOldnowimg],GUICtrlRead($controls[3][0]))
			_update()
			AdlibRegister("_EndVorschau",5000)
		Case $controls[3][2]
			If $iNowimg=2 Then _EndVorschau()
			If $iNowimg=0 Then
				_GDIPlus_BitmapDispose($ahImages[1])
			Else
				_GDIPlus_BitmapDispose($ahImages[0])
				$ahImages[0]=$ahImages[1]
			EndIf
			$ahImages[1]=_FarbFilterAnd($ahImages[0],GUICtrlRead($controls[3][0]))
			$iNowimg=1
			_update()
		Case $controls[4][3]
			If $iNowimg=2 Then _EndVorschau()
			$iOldnowimg=$iNowimg
			$iNowimg=2
			Local $plus="0x",$minus="0x"
			If GUICtrlRead($controls[4][0])<0 Then
				$minus&=Hex(Abs(GUICtrlRead($controls[4][0])),2)
				$plus&="00"
			Else
				$plus&=Hex(GUICtrlRead($controls[4][0]),2)
				$minus&="00"
			EndIf
			If GUICtrlRead($controls[4][1])<0 Then
				$minus&=Hex(Abs(GUICtrlRead($controls[4][1])),2)
				$plus&="00"
			Else
				$plus&=Hex(GUICtrlRead($controls[4][1]),2)
				$minus&="00"
			EndIf
			If GUICtrlRead($controls[4][2])<0 Then
				$minus&=Hex(Abs(GUICtrlRead($controls[4][2])),2)
				$plus&="00"
			Else
				$plus&=Hex(GUICtrlRead($controls[4][2]),2)
				$minus&="00"
			EndIf
			$ahImages[2]=_PlusMinus($ahImages[$iOldnowimg],$plus,$minus)
			_update()
			AdlibRegister("_EndVorschau",5000)
		Case $controls[4][4]
			If $iNowimg=2 Then _EndVorschau()
			If $iNowimg=0 Then
				_GDIPlus_BitmapDispose($ahImages[1])
			Else
				_GDIPlus_BitmapDispose($ahImages[0])
				$ahImages[0]=$ahImages[1]
			EndIf
			Local $plus="0x",$minus="0x"
			If GUICtrlRead($controls[4][0])<0 Then
				$minus&=Hex(Abs(GUICtrlRead($controls[4][0])),2)
				$plus&="00"
			Else
				$plus&=Hex(GUICtrlRead($controls[4][0]),2)
				$minus&="00"
			EndIf
			If GUICtrlRead($controls[4][1])<0 Then
				$minus&=Hex(Abs(GUICtrlRead($controls[4][1])),2)
				$plus&="00"
			Else
				$plus&=Hex(GUICtrlRead($controls[4][1]),2)
				$minus&="00"
			EndIf
			If GUICtrlRead($controls[4][2])<0 Then
				$minus&=Hex(Abs(GUICtrlRead($controls[4][2])),2)
				$plus&="00"
			Else
				$plus&=Hex(GUICtrlRead($controls[4][2]),2)
				$minus&="00"
			EndIf
			$ahImages[1]=_PlusMinus($ahImages[0],$plus,$minus)
			$iNowimg=1
			_update()
		Case $controls[5][2]
			If $iNowimg=2 Then _EndVorschau()
			$iOldnowimg=$iNowimg
			$iNowimg=2
			$ahImages[2]=_Mosaik1($ahImages[$iOldnowimg],GUICtrlRead($controls[5][1]))
			_update()
			AdlibRegister("_EndVorschau",5000)
		Case $controls[5][3]
			If $iNowimg=2 Then _EndVorschau()
			If $iNowimg=0 Then
				_GDIPlus_BitmapDispose($ahImages[1])
			Else
				_GDIPlus_BitmapDispose($ahImages[0])
				$ahImages[0]=$ahImages[1]
			EndIf
			$ahImages[1]=_Mosaik1($ahImages[0],GUICtrlRead($controls[5][1]))
			$iNowimg=1
			_update()
		Case $controls[6][2]
			If $iNowimg=2 Then _EndVorschau()
			$iOldnowimg=$iNowimg
			$iNowimg=2
			$ahImages[2]=_Mosaik2($ahImages[$iOldnowimg],GUICtrlRead($controls[6][1]))
			_update()
			AdlibRegister("_EndVorschau",5000)
		Case $controls[6][3]
			If $iNowimg=2 Then _EndVorschau()
			If $iNowimg=0 Then
				_GDIPlus_BitmapDispose($ahImages[1])
			Else
				_GDIPlus_BitmapDispose($ahImages[0])
				$ahImages[0]=$ahImages[1]
			EndIf
			$ahImages[1]=_Mosaik2($ahImages[0],GUICtrlRead($controls[6][1]))
			$iNowimg=1
			_update()
		Case $controls[7][0]
			If $iNowimg=2 Then _EndVorschau()
			$iOldnowimg=$iNowimg
			$iNowimg=2
			$ahImages[2]=_BitBild($ahImages[$iOldnowimg])
			_update()
			AdlibRegister("_EndVorschau",5000)
		Case $controls[7][1]
			If $iNowimg=2 Then _EndVorschau()
			If $iNowimg=0 Then
				_GDIPlus_BitmapDispose($ahImages[1])
			Else
				_GDIPlus_BitmapDispose($ahImages[0])
				$ahImages[0]=$ahImages[1]
			EndIf
			$ahImages[1]=_BitBild($ahImages[0])
			$iNowimg=1
			_update()
		Case $controls[8][0]
			If $iNowimg=2 Then _EndVorschau()
			$iOldnowimg=$iNowimg
			$iNowimg=2
			$ahImages[2]=_Schwarzweiss($ahImages[$iOldnowimg])
			_update()
			AdlibRegister("_EndVorschau",5000)
		Case $controls[8][1]
			If $iNowimg=2 Then _EndVorschau()
			If $iNowimg=0 Then
				_GDIPlus_BitmapDispose($ahImages[1])
			Else
				_GDIPlus_BitmapDispose($ahImages[0])
				$ahImages[0]=$ahImages[1]
			EndIf
			$ahImages[1]=_Schwarzweiss($ahImages[0])
			$iNowimg=1
			_update()
		Case $controls[9][0]
			If $iNowimg=2 Then _EndVorschau()
			$iOldnowimg=$iNowimg
			$iNowimg=2
			$ahImages[2]=_Negativ($ahImages[$iOldnowimg])
			_update()
			AdlibRegister("_EndVorschau",5000)
		Case $controls[9][1]
			If $iNowimg=2 Then _EndVorschau()
			If $iNowimg=0 Then
				_GDIPlus_BitmapDispose($ahImages[1])
			Else
				_GDIPlus_BitmapDispose($ahImages[0])
				$ahImages[0]=$ahImages[1]
			EndIf
			$ahImages[1]=_Negativ($ahImages[0])
			$iNowimg=1
			_update()
		Case $controls[10][1]
			If $iNowimg=2 Then _EndVorschau()
			$iOldnowimg=$iNowimg
			$iNowimg=2
			Local $file
			_GUICtrlComboBox_GetLBText($controls[10][0],_GUICtrlComboBox_GetCurSel($controls[10][0]),$file)
			$ahImages[2]=_LaunchExt($ahImages[$iOldnowimg],$file)
			_update()
			AdlibRegister("_EndVorschau",5000)
		Case $controls[10][2]
			If $iNowimg=2 Then _EndVorschau()
			If $iNowimg=0 Then
				_GDIPlus_BitmapDispose($ahImages[1])
			Else
				_GDIPlus_BitmapDispose($ahImages[0])
				$ahImages[0]=$ahImages[1]
			EndIf
			Local $file
			_GUICtrlComboBox_GetLBText($controls[10][0],_GUICtrlComboBox_GetCurSel($controls[10][0]),$file)
			$ahImages[1]=_LaunchExt($ahImages[0],$file)
			$iNowimg=1
			_update()
	EndSwitch ;Extension
	Sleep(10)
WEnd



AdlibUnRegister()
For $x=0 To 2
	_GDIPlus_BitmapDispose($ahImages[$x])
Next
_GDIPlus_GraphicsDispose($backgra)
_GDIPlus_BitmapDispose($hBuffer)
_GDIPlus_GraphicsDispose($gra)
_GDIPlus_Shutdown()
Exit



Func _EndVorschau()
	AdlibUnRegister("_EndVorschau")
	$iNowimg=$iOldnowimg
	_GDIPlus_BitmapDispose($ahImages[2])
	_update()
EndFunc

Func _update()
	_GDIPlus_GraphicsClear($backgra,0x00000000)
	_GDIPlus_GraphicsDrawImageRect($backgra,$ahImages[$iNowimg],110,40,$iW,$iH)
	_GDIPlus_GraphicsDrawImageRect($gra,$hBuffer,0,0,1010,640)
EndFunc

Func update($hWnd, $Msg, $wParam, $lParam)
	If $wParam<>0 Then _update()
EndFunc



Func _LaunchExt($bmp,$datei)
	If $bmp = 0 Then Return SetError(2, 1, 0)
	Local $w = _GDIPlus_ImageGetWidth($bmp), $h = _GDIPlus_ImageGetHeight($bmp)
	Local $hbmp = _GDIPlus_BitmapCreateHBITMAPFromBitmap($bmp)
	Local $dc, $xbmp, $ptr
	$dc = _CreateNewBmp32($w, $h, $ptr, $xbmp)
	Local $xdc = _WinAPI_CreateCompatibleDC(0)
	_WinAPI_SelectObject($xdc, $hbmp)
	_WinAPI_BitBlt($dc, 0, 0, $w, $h, $xdc, 0, 0, $SRCCOPY)

	Local $data,$size,$file=FileOpen(@ScriptDir&"\Extensions\bin\"&$datei&".bin",16)
	$data=FileRead($file)
	FileClose($file)
	$size=StringLen($data)/2-1
	Local $tCodeBuffer = DllStructCreate("byte["&$size&"]")
	DllStructSetData($tCodeBuffer, 1, $data)

	Local $info[4],$var[4]
	$file=FileOpen(@ScriptDir&"\Extensions\info\"&$datei&".txt",0)
	For $i=1 To 4
		$info[$i-1]=FileReadLine($file)
		$var[$i-1]=Execute(FileReadLine($file))
	Next
	FileClose($file)

	DllCall("user32.dll", "none", "CallWindowProcW", "ptr", DllStructGetPtr($tCodeBuffer),$info[0], $var[0], $info[1], $var[1], $info[2], $var[2], $info[3], $var[3])

	Local $ret = _GDIPlus_BitmapCreateFromHBITMAP($xbmp)
	_WinAPI_DeleteDC($xdc)
	_DeleteBitmap32($dc,$ptr,$xbmp)
	_WinAPI_DeleteObject($hbmp)
	Return $ret
EndFunc






